/*--------------------------------------------------------------------------
     (C) Copyright Novell, Inc. 1991  All Rights Reserved.

 No part of this file may be duplicated, revised, translated, localized or
 modified in any manner or compiled, linked, or uploaded or downloaded to or
 from any computer system without the prior written consent of Novell, Inc.
--------------------------------------------------------------------------*/
#ifndef NWDEL_INC
#define NWDEL_INC

#ifndef NWCALDEF_INC
# include <nwcaldef.h>
#endif
typedef struct
{
  DWORD  sequence;
  DWORD  parent;
  DWORD  attributes;
  BYTE   uniqueID;
  BYTE   flags;
  BYTE   nameSpace;
  BYTE   nameLength;
  BYTE   name [256];
  DWORD  creationDateAndTime;
  DWORD  ownerID;
  DWORD  lastArchiveDateAndTime;
  DWORD  lastArchiverID;
  DWORD  updateDateAndTime;
  DWORD  updatorID;
  DWORD  fileSize;
  BYTE   reserved[44];
  WORD   inheritedRightsMask;
  WORD   lastAccessDate;
  DWORD  deletedTime;
  DWORD  deletedDateAndTime;
  DWORD  deletorID;
  BYTE   reserved3 [16];
} NWDELETED_INFO;

#ifdef __cplusplus
extern "C" {
#endif
NWCCODE NWAPI NWPurgeDeletedFile(
  NWCONN_HANDLE conn,
  NWDIR_HANDLE dirHandle,
  DWORD sequence,
  DWORD volume,
  DWORD dirBase,
  BYTE NWPTR fileName);

NWCCODE NWAPI NWRecoverDeletedFile(
  NWCONN_HANDLE conn,
  NWDIR_HANDLE dirHandle,
  DWORD sequence,
  DWORD volume,
  DWORD dirBase,
  char NWPTR deletedFileName,
  char NWPTR recoverFileName);

NWCCODE NWAPI NWScanForDeletedFiles(
  NWCONN_HANDLE conn,
  NWDIR_HANDLE dirHandle,
  DWORD NWPTR sequence,
  DWORD NWPTR volume,
  DWORD NWPTR dirBase,
  NWDELETED_INFO NWPTR entryInfo);

NWCCODE NWAPI NWPurgeErasedFiles(NWCONN_HANDLE conn);

NWCCODE NWAPI NWRestoreErasedFile(
  NWCONN_HANDLE conn,
  NWDIR_HANDLE dirHandle,
  char NWPTR dirPath,
  char NWPTR oldName,
  char NWPTR newName);
#ifdef __cplusplus
}
#endif

#endif
