/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/
#ifndef	_NWDSASA_HEADER_
#define	_NWDSASA_HEADER_

#ifndef __NWDSTYPE_H
#include <nwdstype.h>
#endif

#ifndef	_NWDSDC_HEADER_
#include "nwdsdc.h"		/* for NWDSContextHandle typedef	*/
#endif

#ifndef NWCONNECT_INC
#include "nwconnec.h"
#endif

#define SESSION_KEY_SIZE	16
typedef	uint8	NWDS_Session_Key_T[SESSION_KEY_SIZE];	/* Optional session key */

#define	GENERATE_CERTIFICATION_KP_F			1

#ifdef MACINTOSH
#include "nwcaldef.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

NWDSCCODE NWAPI  NWDSAuthenticate
(
	NWCONN_HANDLE		conn,
	uint32				optionsFlag, 
	NWDS_Session_Key_T NWPTR sessionKey
);

NWDSCCODE NWAPI  NWDSChangeObjectPassword
(
	NWDSContextHandle context, 
	uint32 optionsFlag, 
	char NWPTR objectName, 
	char NWPTR oldPassword,
	char NWPTR newPassword
);

NWDSCCODE NWAPI  NWDSGenerateObjectKeyPair
(
	NWDSContextHandle	contextHandle,
	char		NWPTR objectName,
	char		NWPTR objectPassword,
	uint32	optionsFlag
);

NWDSCCODE NWAPI  NWDSLogin
(
	NWDSContextHandle	context, 
	uint32	optionsFlag, 
	char NWPTR objectName, 
	char NWPTR password,
	uint32 validityPeriod
);

NWDSCCODE NWAPI  NWDSLogout
(
	NWDSContextHandle	context
);

NWDSCCODE NWAPI  NWDSVerifyObjectPassword
(
	NWDSContextHandle context, 
	uint32 optionsFlag,
	char NWPTR objectName,
	char NWPTR password
);

#ifdef __cplusplus
}
#endif

#endif


