#ifndef	_NWDSATTR_HEADER_
#define	_NWDSATTR_HEADER_

/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/

#ifndef __NWDSTYPE_H
#include <nwdstype.h>
#endif

#ifndef	_NWDSDC_HEADER_
#include <nwdsdc.h>
#endif


#define	TIME_BITMAP_LEN					42
#define  NUM_POSTAL_ADDRESS_ELEMENTS	6

typedef	char 	NWPTR CE_String_T;
typedef	char 	NWPTR Class_Name_T;
typedef	char 	NWPTR CI_String_T;
typedef	char 	NWPTR CN_String_T;
typedef 	char	NWPTR DN_T;
typedef	int32	Integer_T;
typedef	uint8	Boolean_T;
typedef	char 	NWPTR NU_String_T;
typedef	char 	NWPTR Postal_Address_T[NUM_POSTAL_ADDRESS_ELEMENTS];
typedef	char 	NWPTR PR_String_T;
typedef	char 	NWPTR Secure_Name_T;
typedef	char 	NWPTR TN_String_T;
typedef	uint32 Counter_T;

typedef struct
{
	uint32	remoteID;
	char		NWPTR objectName;
} Back_Link_T;

typedef struct	
{
	uint32		numOfBits;
	uint8			NWPTR data;
} Bit_String_T;

typedef	struct _ci_list
{
	struct _ci_list 	NWPTR next;
	char					NWPTR s;
} CI_List_T;

typedef	struct 
{
	char 				NWPTR telephoneNumber;
	Bit_String_T	parameters;
}Fax_Number_T;

typedef struct
{
	char		NWPTR objectName;
	uint32	level;
	uint32	interval;
} Typed_Name_T;

typedef struct	
{
	uint32		addressType;
	uint32		addressLength;
	uint8			NWPTR address;
} Net_Address_T;

typedef	struct 
{
 	char			NWPTR protectedAttrName;
	char			NWPTR subjectName;
	uint32		privileges;
} Object_ACL_T;

typedef	struct 
{
	uint32		length;
	uint8			NWPTR data;
} Octet_String_T;

typedef Octet_String_T	Stream_T;

typedef	struct _octet_list
{
	struct _octet_list	NWPTR next;
	uint32		  			length;
	uint8			  			NWPTR data;
} Octet_List_T;

typedef struct
{
	char		NWPTR objectName;
	uint32	amount;
} Hold_T;

typedef struct	
{
	char		NWPTR serverName;
	int32				replicaType;
	int32				replicaNumber;
	uint32			count;
	Net_Address_T	replicaAddressHint[1];
} Replica_Pointer_T;
						 
typedef struct
{
	uint32	type;
	char		NWPTR address;
} EMail_Address_T;

typedef struct
{
	uint32	nameSpaceType;
	char		NWPTR volumeName;
	char		NWPTR path;
} Path_T;

typedef struct
{
     uint32	wholeSeconds;
     uint32	eventID;
} NWDS_TimeStamp_T;

typedef struct
{
	char		NWPTR attrName;
	uint32	syntaxID;
	uint32	valueLen;
	void		NWPTR value;	 
} Unknown_Attr_T;

#endif									/* #ifndef _NWDSATTR_HEADER_ */

