#ifndef	_NWDSBUFT_HEADER_			
#define	_NWDSBUFT_HEADER_			

/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/

#include <time.h>

#ifndef __NWDSTYPE_H
#include <nwdstype.h>
#endif

#ifndef	_NWDSDC_HEADER_
#include <nwdsdc.h>
#endif

#ifndef	__NWDSDEFS_H
#include <nwdsdefs.h>
#endif

#ifndef	_NWDSATTR_HEADER_
#include <nwdsattr.h>
#endif

                                  
#define	INPUT_BUFFER	0x00000001

typedef struct
{
	uint32	operation;
	uint32	flags;
	uint32	maxLen;
	uint32	curLen;
	uint8		NWPTR lastCount;
	uint8		NWPTR curPos;
	uint8		NWPTR data;
} Buf_T;

typedef struct
{
	uint32	objectFlags;
	uint32	subordinateCount;
	time_t	modificationTime;
	char		baseClass[MAX_SCHEMA_NAME_BYTES + 2];
} Object_Info_T;

typedef struct
{
	uint32			length;
	uint8				data[MAX_ASN1_NAME];
} Asn1ID_T;

typedef struct
{
	uint32			attrFlags;
	uint32			attrSyntaxID;
	uint32			attrLower;
	uint32			attrUpper;
	Asn1ID_T			asn1ID;
} Attr_Info_T;

typedef struct	
{
	uint32			classFlags;
	Asn1ID_T			asn1ID;		/* an object identifier created allocated   */
} Class_Info_T;					/* according to the rules specified in the  */
										/* ASN.1 standard; if no object identifier  */
										/* has been registered for the class, a     */
										/* zero-length octet string is specified    */

typedef struct
{
	int16	ID;
	char	defStr[MAX_SCHEMA_NAME_BYTES + 2];
	int16 	flags;
} Syntax_Info_T;

#define NWDSPutClassName(c, b, n) NWDSPutClassItem(c, b, n) /* 
																					c -- context
						                                             b -- buf
                                                               n -- itemName
																				*/

#define NWDSPutSyntaxName(c, b, n) NWDSPutClassItem(c, b, n) /* 
																					c -- context
						                                             b -- buf
                                                               n -- itemName
																				*/
#ifdef __cplusplus
	extern "C" {
#endif

NWDSCCODE NWAPI NWDSAllocBuf
(
	size_t	size,
	Buf_T		NWPTR  NWPTR buf
);

NWDSCCODE NWAPI NWDSComputeAttrValSize
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	syntaxID,
	uint32	NWPTR attrValSize
);

NWDSCCODE NWAPI NWDSFreeBuf
(
	Buf_T		NWPTR buf
);

NWDSCCODE NWAPI NWDSGetAttrCount
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	NWPTR attrCount
);

NWDSCCODE NWAPI NWDSGetAttrDef
(
	NWDSContextHandle			context,
	Buf_T			NWPTR buf,
	char			NWPTR attrName,
	Attr_Info_T	NWPTR attrInfo
);

NWDSCCODE NWAPI NWDSGetAttrName
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	char		NWPTR attrName,
	uint32	NWPTR attrValCount,
	uint32	NWPTR syntaxID

);

NWDSCCODE NWAPI NWDSGetAttrVal
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	syntaxID,
	void		NWPTR attrVal
);

NWDSCCODE NWAPI NWDSGetClassDef
(
 	NWDSContextHandle				context,	
	Buf_T				NWPTR buf,
	char				NWPTR className,
	Class_Info_T	NWPTR classInfo
);

NWDSCCODE NWAPI NWDSGetClassDefCount
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	NWPTR classDefCount
);

NWDSCCODE NWAPI NWDSGetClassItem
(
	NWDSContextHandle		context,	
	Buf_T		NWPTR buf,
	char		NWPTR itemName
);

NWDSCCODE NWAPI NWDSGetClassItemCount
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	NWPTR itemCount
);

NWDSCCODE NWAPI NWDSGetObjectCount
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	NWPTR objectCount
);

NWDSCCODE NWAPI NWDSGetObjectName
(
	NWDSContextHandle				context,
	Buf_T				NWPTR buf,
	char				NWPTR objectName,
	uint32			NWPTR attrCount,
	Object_Info_T	NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSGetPartitionInfo
(
	NWDSContextHandle				context,
	Buf_T				NWPTR buf,
	char				NWPTR partitionName,
	uint32			NWPTR replicaType
);

NWDSCCODE NWAPI NWDSGetServerName
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	char		NWPTR serverName,
	uint32	NWPTR partitionCount
);

NWDSCCODE NWAPI NWDSGetSyntaxCount
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	NWPTR syntaxCount
);

NWDSCCODE NWAPI NWDSGetSyntaxDef
(
	NWDSContextHandle		context, 
	Buf_T		NWPTR buf,
	char		NWPTR syntaxName,
	Syntax_Info_T	NWPTR syntaxDef
);

NWDSCCODE NWAPI NWDSInitBuf
(
	NWDSContextHandle		context, 
	uint32	operation,
	Buf_T		NWPTR buf		
);

NWDSCCODE NWAPI NWDSPutAttrName
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	char		NWPTR attrName
);

NWDSCCODE NWAPI NWDSPutAttrVal
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	uint32	syntaxID,
	void		NWPTR attrVal
);

NWDSCCODE NWAPI NWDSPutChange
(
	NWDSContextHandle 		context,	
	Buf_T		NWPTR buf,	
	uint32	changeType,	
	char  	NWPTR attrName
);

NWDSCCODE NWAPI NWDSPutClassItem
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf,
	char		NWPTR itemName
);

NWDSCCODE NWAPI NWDSBeginClassItem
(
	NWDSContextHandle		context,
	Buf_T		NWPTR buf
);

#ifdef __cplusplus
	}
#endif

#endif									/* #ifndef _NWDSBUFT_HEADER_ */
