#ifndef 	_NWDSMISC_HEADER_
#define	_NWDSMISC_HEADER_
/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/
#ifndef __NWDSTYPE_H
#include <nwdstype.h>
#endif

#ifndef _NWDSBUFT_HEADER_
#include <nwdsbuft.h>
#endif

#ifndef	_NWDSDC_HEADER_
#include <nwdsdc.h>
#endif

#ifndef NWCONNECT_INC
#include <nwconnec.h>
#endif

#define DS_SYNTAX_NAMES		0
#define DS_SYNTAX_DEFS		1

#define DS_STRING					0x0001	/* string, can be used in names */
#define DS_SINGLE_VALUED		0x0002
#define DS_SUPPORTS_ORDER		0x0004
#define DS_SUPPORTS_EQUAL		0x0008
#define DS_IGNORE_CASE			0x0010	/* Ignore case 			*/
#define DS_IGNORE_SPACE			0x0020	/* Ignore white space 	*/
#define DS_IGNORE_DASH			0x0040	/* Ignore dashes 			*/
#define DS_ONLY_DIGITS			0x0080
#define DS_ONLY_PRINTABLE		0x0100
#define DS_SIZEABLE				0x0200

#ifdef __cplusplus
	extern "C" {
#endif

NWDSCCODE NWAPI NWDSCloseIteration
(
 	NWDSContextHandle	context,
	int32					iterationHandle,
	uint32				operation
);

NWDSCCODE NWAPI  NWDSGetSyntaxID
(
	NWDSContextHandle context, 
	char NWPTR attrName, 
	uint32 NWPTR syntaxID
);

NWDSCCODE NWAPI  NWDSReadSyntaxes
(
	NWDSContextHandle	context,
	uint32	infoType,
	uint8		allSyntaxes,
	Buf_T		NWPTR syntaxNames,
	int32		NWPTR iterationHandle,
	Buf_T		NWPTR syntaxDefs
);

NWDSCCODE NWAPI  NWDSReadSyntaxDef
(
	NWDSContextHandle		context,
	uint32					syntaxID,
	Syntax_Info_T NWPTR syntaxDef
);

NWDSCCODE NWAPI  NWDSReplaceAttrNameAbbrev
(
	NWDSContextHandle context,
	char NWPTR inStr, 
	char NWPTR outStr
);

NWDSCCODE NWAPI  NWDSGetObjectHostServerAddress
(
	NWDSContextHandle context,
	char NWPTR objectName,
	char NWPTR serverName,
	Buf_T NWPTR netAddresses
);

void NWAPI  NWGetNWNetVersion
(
	uint8 NWPTR majorVersion,
   uint8 NWPTR minorVersion,
	uint8 NWPTR revisionLevel,
   uint8 NWPTR betaReleaseLevel 
);

NWDSCCODE NWAPI  NWIsDSServer
(
	NWCONN_HANDLE		conn,
	char NWPTR treeName
);

NWDSCCODE NWAPI  NWDSGetBinderyContext
(
	NWDSContextHandle	context,
	NWCONN_HANDLE		conn,
	uint8 NWPTR BinderyEmulationContext
);

NWDSCCODE NWAPI  NWDSRepairTimeStamps
(
	NWDSContextHandle	context,
	char NWPTR partitionRoot
);

int	NWAPI  NWGetFileServerUTCTime
(
	NWCONN_HANDLE		conn,
	uint32 NWPTR time
);


#ifdef __cplusplus
	}
#endif

#endif
