#ifndef _UNICODE_HEADER_
#define _UNICODE_HEADER_
/****************************************************************************
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written consent of
 * Novell, Inc.
 ****************************************************************************/

#ifdef __BORLANDC__
#  ifndef _SIZE_T
#    define _SIZE_T
     typedef unsigned size_t;
#  endif
#elif defined(NWNLM)
#  include <stddef.h>
#elif defined(__WATCOMC__)
#  ifndef _SIZE_T_DEFINED_
#    define _SIZE_T_DEFINED_
     typedef unsigned size_t;
#  endif
#else
#  ifndef _SIZE_T_DEFINED
#    define _SIZE_T_DEFINED
     typedef unsigned int size_t;
#  endif
#endif

#ifndef NWNLM
#ifndef NWAPI
#define NWAPI far pascal
#endif

#if defined(MEDIUM_MODEL)
#undef NWFAR
#define NWFAR
#endif

#ifndef NWFAR
#define NWFAR far
#endif

#else /* NWNLM */
#undef NWAPI
#define NWAPI
#undef NWFAR
#define NWFAR
#endif

/****************************************************************************/

/*
    Definition of a Unicode character - Must be 16 bits wide
*/
typedef unsigned short unicode;

/****************************************************************************/

/*
    True and False
*/
#ifndef TRUE
# define TRUE    1
#endif
#ifndef FALSE
# define FALSE   0
#endif

/*
    Error codes
*/
#define UNI_ALREADY_LOADED   -489  /* Already loaded another country or code page */
#define UNI_FUTURE_OPCODE    -490  /* Rule table has unimplimented rules*/
#define UNI_NO_SUCH_FILE     -491  /* No such file or directory */
#define UNI_TOO_MANY_FILES   -492  /* Too many files already open */
#define UNI_NO_PERMISSION    -493  /* Permission denied on file open */
#define UNI_NO_MEMORY        -494  /* Not enough memory */
#define UNI_LOAD_FAILED      -495  /* NWLoadRuleTable failed, don't know why */
#define UNI_HANDLE_BAD       -496  /* Rule table handle was bad */
#define UNI_HANDLE_MISMATCH  -497  /* Rule table handle doesn't match operation*/
#define UNI_RULES_CORRUPT    -498  /* Rule table is corrupt */
#define UNI_NO_DEFAULT       -499  /* No default rule and no 'No map' character*/
#define UNI_INSUFFICIENT_BUFFER -500
#define UNI_OPEN_FAILED      -501  /* Open failed in NWLoadRuleTable */
#define UNI_NO_LOAD_DIR      -502  /* Load directory could not be determined */

/****************************************************************************/

/*
  Functions in Unicode.Lib that have no counterpart in string.h
*/

#ifdef __cplusplus
    extern "C" {
#endif

/*
  Memory models with near returns require different libc calls
     NWInitUnicodeTables()
     NWFreeUnicodeTables()
     NWLoadRuleTable()
     NWUnloadRuleTable()
  MSC uses M_I86TM, M_I86SM and M_I86CM for tiny, small and compact.
  Borland, Zortech and Watcom all use __TINY__ and __SMALL__ __COMPACT__.
*/

#if (defined(NWDOS) && \
      (defined(M_I86SM) || defined(M_I86TM) || defined(M_I86CM) || \
      defined(__SMALL__) || defined(__TINY__) || defined(__COMPACT__)))

#define NWInitUnicodeTables     NWNInitUnicodeTables
INT16 NWAPI NWNInitUnicodeTables(
   INT16            countryCode, 
   INT16            codePage);

#define NWFreeUnicodeTables     NWNFreeUnicodeTables
INT16 NWAPI NWNFreeUnicodeTables(
   void);

#define NWLoadRuleTable         NWNLoadRuleTable
INT16 NWAPI NWNLoadRuleTable(          /* Load a rule table                   */
   char     NWPTR ruleTableName,   /* Name of the rule table              */
   void NWPTR  NWPTR ruleHandle); /* Where to put the rule table handle  */

#define NWUnloadRuleTable       NWNUnloadRuleTable
INT16 NWAPI NWNUnloadRuleTable(        /* Unload a rule table                 */
   void     NWPTR ruleHandle);     /* Rule table handle                   */

#else  /* small model */

INT16 NWAPI NWInitUnicodeTables(
   INT16            countryCode, 
   INT16            codePage);

INT16 NWAPI NWFreeUnicodeTables(
   void);

INT16 NWAPI NWLoadRuleTable(          /* Load a rule table                   */
   char     NWPTR ruleTableName,   /* Name of the rule table              */
   void NWPTR  NWPTR ruleHandle); /* Where to put the rule table handle  */

INT16 NWAPI NWUnloadRuleTable(        /* Unload a rule table                 */
   void     NWPTR ruleHandle);     /* Rule table handle                   */
#endif   /* small model */


INT16 NWAPI NWLocalToUnicode(         /* Convert local to Unicode            */
   void     NWPTR ruleHandle,      /* Rule table handle                   */
   unicode  NWPTR dest,            /* Buffer for resulting Unicode        */
   size_t         maxLen,           /* Size of results buffer              */
#ifndef MACINTOSH
   char     NWPTR src,             /* Buffer with source local code       */
#else
   void           *src,
#endif
   unicode        noMap,            /* No map character                    */
   size_t   NWPTR len);            /* Number of unicode chars in output   */

INT16 NWAPI NWUnicodeToLocal(         /* Convert Unicode to local code       */
   void     NWPTR ruleHandle,      /* Rule table handle                   */
#ifndef MACINTOSH
   char     NWPTR dest,            /* Buffer for resulting local code     */
#else
   void           *dest,
#endif
   size_t         maxLen,           /* Size of results buffer              */
   unicode  NWPTR src,             /* Buffer with source Unicode          */
   char           noMap,            /* No Map character                    */
   size_t   NWPTR len);            /* Number of bytes in output           */

INT16 NWAPI NWUnicodeToCollation(     /* Convert Unicode to collation        */
   void     NWPTR ruleHandle,      /* Rule table handle                   */
   unicode  NWPTR dest,            /* Buffer for resulting Unicode weights*/
   size_t         maxLen,           /* Size of results buffer              */
   unicode  NWPTR src,             /* Buffer with source Unicode          */
   unicode        noMap,            /* No map character                    */
   size_t   NWPTR len);            /* Number of unicode chars in output   */

INT16 NWAPI NWUnicodeCompare(         /* Compare two unicode characters      */
   void     NWPTR ruleHandle,      /* Rule table handle                   */
   unicode        chr1,             /* 1st character                       */
   unicode        chr2);            /* 2nd character                       */

INT16 NWAPI NWUnicodeToMonocase(      /* Convert Unicode to collation        */
   void     NWPTR ruleHandle,      /* Rule table handle                   */
   unicode  NWPTR dest,            /* Buffer for resulting Unicode weights*/
   size_t         maxLen,           /* Size of results buffer              */
   unicode  NWPTR src,             /* Buffer with source Unicode          */
   size_t   NWPTR len);            /* Number of unicode chars in output   */

INT16 NWAPI NWGetUnicodeToLocalHandle(
   void NWPTR  NWPTR handle);

INT16 NWAPI NWGetLocalToUnicodeHandle(
   void NWPTR  NWPTR handle);

INT16 NWAPI NWGetMonocaseHandle(
   void NWPTR  NWPTR handle);

INT16 NWAPI NWGetCollationHandle(
   void NWPTR  NWPTR handle);

/****************************************************************************/

/*
    Functions in Unicode.Lib that work like those in string.h
*/
unicode NWPTR  NWAPI unicat(    /* Corresponds to strcat               */
   unicode  NWPTR s1,           /* Original string                     */
   unicode  NWPTR s2);          /* String to be appended               */

unicode NWPTR  NWAPI unichr(    /* Corresponds to strchr               */
   unicode  NWPTR s,            /* String to be scanned                */
   INT16            c);            /* Character to be found               */

unicode NWPTR  NWAPI unicpy(    /* Corresponds to strcpy               */
   unicode  NWPTR s1,           /* Destination string                  */
   unicode  NWPTR s2);          /* Source string                       */

size_t NWAPI unicspn(            /* Corresponds to strcspn              */
   unicode  NWPTR s1,           /* String to be scanned                */
   unicode  NWPTR s2);          /* Character set                       */

size_t NWAPI unilen(             /* Corresponds to strlen               */
   unicode  NWPTR s);           /* String to determine length of       */

unicode NWPTR  NWAPI unincat(   /* Corresponds to strncat              */
   unicode  NWPTR s1,           /* Original string                     */
   unicode  NWPTR s2,           /* String to be appended               */
   size_t         n);            /* Maximum characters to be appended   */

unicode NWPTR  NWAPI unincpy(   /* Corresponds to strncpy              */
   unicode  NWPTR s1,           /* Destination string                  */
   unicode  NWPTR s2,           /* Source string                       */
   size_t         n);            /* Maximum length                      */

unicode NWPTR  NWAPI uninset(   /* Corresponds to strnset              */
   unicode  NWPTR s,            /* String to be modified               */
   INT16            c,             /* Fill character                      */
   size_t         n);            /* Maximum length                      */

unicode NWPTR  NWAPI unipbrk(   /* Corresponds to strpbrk              */
   unicode  NWPTR s1,           /* String to be scanned                */
   unicode  NWPTR s2);          /* Character set                       */

unicode NWPTR  NWAPI unipcpy(   /* Corresponds to strpcpy              */
   unicode  NWPTR s1,           /* Destination string                  */
   unicode  NWPTR s2);          /* Source string                       */

unicode NWPTR  NWAPI unirchr(   /* Corresponds to strrchr              */
   unicode  NWPTR s,            /* String to be scanned                */
   INT16            c);            /* Character to be found               */

unicode NWPTR  NWAPI unirev(    /* Corresponds to strrev               */
   unicode  NWPTR s);           /* String to be reversed               */

unicode NWPTR  NWAPI uniset(    /* Corresponds to strset               */
   unicode  NWPTR s,            /* String to modified                  */
   INT16            c);            /* Fill character                      */

size_t NWAPI unispn(             /* Corresponds to strspn               */
   unicode  NWPTR s1,           /* String to be tested                 */
   unicode  NWPTR s2);          /* Character set                       */

unicode NWPTR  NWAPI unistr(    /* Corresponds to strstr               */
   unicode  NWPTR s1,           /* String to be scanned                */
   unicode  NWPTR s2);          /* String to be located                */

unicode NWPTR  NWAPI unitok(    /* Corresponds to strtok               */
   unicode  NWPTR s1,           /* String to be parsed                 */
   unicode  NWPTR s2);          /* Delimiter values                    */

INT16 NWAPI uniicmp(               /* Corresponds to stricmp              */
   unicode  NWPTR s1,           /* 1st string to be compared           */
   unicode  NWPTR s2);          /* 2nd string to be compared           */

INT16 NWAPI uninicmp(              /* Corresponds to strnicmp             */
   unicode  NWPTR s1,           /* 1st string to be compared           */
   unicode  NWPTR s2,           /* 2nd string to be compared           */
   size_t         n);            /* Maximum length                      */

#ifndef MACINTOSH
size_t NWAPI unisize(            /* Corresponds to sizeof               */
   unicode  NWPTR s);
#else
# define unisize(uS)  ((unilen((unicode *) uS) + 1) * sizeof(unicode))
#endif

#ifdef __cplusplus
    }
#endif

/****************************************************************************/
/****************************************************************************/
#endif
